#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import urllib,re,os
import xbmcplugin,xbmcgui
import xbmcaddon,xbmc
import requests

addon = xbmcaddon.Addon(id='plugin.video.meintvanime')
home = addon.getAddonInfo('path').decode('utf-8')
image = xbmc.translatePath(os.path.join(home, 'icon.png'))
datapath = xbmc.translatePath('special://profile/addon_data/plugin.video.meintvanime/')
favs = os.path.join(datapath,'favs.txt')

if not os.path.isdir(datapath):
  os.mkdir(datapath)

pluginhandle = int(sys.argv[1])

def kategorien():
        addDir('Neue Anime','http://www.mein.tv',1,image,'','','','','')
        addDir('Neue Episoden','http://www.mein.tv',5,image,'','','','','')
        addDir('Serien','',6,image,'','','','','')
	addDir('Filme','http://www.mein.tv/Indexs/?s=g&t=3&w=g&r=g&a=g&g=g',2,image,'','','','','')
	addDir('Ovas','http://www.mein.tv/Indexs/?s=g&t=2&w=g&r=g&a=g&g=g',2,image,'','','','','')
        addDir('MAD-AMV','http://www.mein.tv/Anime/MAD%C2%B7AMV',10,image,'','','','','')
        addDir('Suche','http://www.mein.tv/search/?keyword=',11,image,'','','','','')
        addDir('Meine Anime','',13,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def meine():
	if os.path.exists(favs):
	  fh = open(favs, 'r')
	  content = fh.read()
	  match = re.findall('{"name":"(.*?)","url":"(.*?)","cover":"(.*?)","plot":"(.*?)"}', content, re.DOTALL)
	  for name,url,cover,plot in match:
	    cm = []
	    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&mode="+urllib.quote_plus('15')+"&iconimage="+urllib.quote_plus(cover)+"&plot="+urllib.quote_plus(plot)
	    cm.append( ('von Meine Anime entfernen', "XBMC.RunPlugin(%s)" % u) )
	    addDir(name,url,3,cover,plot,'','','','',cm=cm)
	  fh.close()
        xbmcplugin.endOfDirectory(pluginhandle)

def add():
	name = urllib.unquote_plus(params['name'])
	url = urllib.unquote_plus(params['url'])
	cover = urllib.unquote_plus(params['iconimage'])
	plot = urllib.unquote_plus(params['plot'])
	amventry = '{"name":"'+name+'","url":"'+url+'","cover":"'+cover+'","plot":"'+plot+'"}'
	if os.path.exists(favs):
	  fh = open(favs, 'r')
	  content = fh.read()
	  fh.close()
	  if content.find(amventry) == -1:
	    fh = open(favs, 'a')
	    fh.write(amventry+"\n")
	    fh.close()
	else:
	  fh = open(favs, 'a')
	  fh.write(amventry+"\n")
	  fh.close()
        xbmc.executebuiltin('XBMC.Notification(Info: Anime hinzugefuegt!,5000)')

def rem():
	name = urllib.unquote_plus(params['name'])
	url = urllib.unquote_plus(params['url'])
	cover = urllib.unquote_plus(params['iconimage'])
	plot = urllib.unquote_plus(params['plot'])
	amventry = '{"name":"'+name+'","url":"'+url+'","cover":"'+cover+'","plot":"'+plot+'"}'
	fh = open(favs, 'r')
	content = fh.read()
	fh.close()
	entry = content[content.find(amventry):]
	fh = open(favs, 'w')
	fh.write(content.replace(amventry+"\n", ""))
	fh.close()
        xbmc.executebuiltin('XBMC.Notification(Info: Anime entfernt!,5000)')

def neueanime(url):
        content = getUrl(url)
	match = re.findall('>Neue Anime</a>(.*?)</li>', content)
        rematch = re.findall('"(http://www.mein.tv/Neue_Anime/.*?)">(.*?)</a>', match[0])
        for url,name in rematch:
          addDir(name,url,2,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def neueepisoden(url):
	content = getUrl(url)
	match = re.findall('Laufende Serien(.*?)<div class="mehr">', content)
        rematch = re.findall('<li class="v_h">.*?<a href="(.*?)".*?<img src="(.*?)".*?<em>(.*?)</em>.*?<a href.*?>(.*?)</a>', match[0])
        for url,thumb,part1,part2 in rematch:
          thumb = 'http://www.mein.tv/' + thumb
          name = part1 + ' - ' + part2
          addLink(name,url,4,thumb)

def serien():
	addDir('Alphabetisch','http://www.mein.tv/Indexs/?s=g&t=1&w=g&r=g&a=g&g=g',7,image,'','','','','')
	addDir('Jahr','http://www.mein.tv/Indexs/?s=g&t=1&w=g&r=g&a=g&g=g',8,image,'','','','','')
	addDir('Genre','http://www.mein.tv/Indexs/?s=g&t=1&w=g&r=g&a=g&g=g',9,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def abc(url):
	content = getUrl(url)
	match = re.findall('<i>Alphabetisch:</i>.*?</div>', content)
	rematch = re.findall('<a href="(.*?)">(.*?)</a>', match[0])
        for url,name in rematch:
          addDir(name,url,2,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def jahr(url):
	content = getUrl(url)
	match = re.findall('<i>Jahr:</i>.*?</div>', content)
	rematch = re.findall('<a href="(.*?)">(.*?)</a>', match[0])
        for url,name in rematch:
          addDir(name,url,2,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def genre(url):
	content = getUrl(url)
	match = re.findall('<i>Genre:</i>.*?</div>', content)
	rematch = re.findall('<a href="(.*?)">(.*?)</a>', match[0])
        for url,name in rematch:
          addDir(name,url,2,image,'','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def madamv(url):
        content = getUrl(url)
        match = re.findall('<ul class="v_list_a">(.*?)</ul>', content)
        rematch = re.findall('<img src="(.*?)".*?<a href="(.*?)" class="title">(.*?)</a>', match[0])
        for thumb,url,name in rematch:
          addLink(name,url,4,thumb)
        if 'Previous' in content:
          next = re.findall('<div class="pagination">(.*?)</div>', content)
          renext = re.findall('<a href=".*?page(.*?)".*?>(.*?)</a>', next[0])
          for page,name in renext:
            if 'Next' in name:
              url = 'http://www.mein.tv/Anime/MAD%C2%B7AMV?' + 'page' + page
              addDir(name,url,10,'','','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def suche(url):
        kb = xbmc.Keyboard('', 'Suche', False)
        kb.doModal()
        search_entered = kb.getText().replace(' ','+')
        url = url + search_entered
        listsuche(url)
	content = getUrl(url)
        if 'Previous' in content:
          next = re.findall('<div class="pagination">(.*?)</div>', content)
          renext = re.findall('<a href="(http://www.mein.tv/.*?page.*?)".*?>(.*?)</a>', next[0])
          for url,name in renext:
            if 'Next' in name:
              addDir(name,url,12,'','','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def listsuche(url):
	content = getUrl(url)
        match = re.findall('div class="pic">.*?<img src="(.*?)".*?<i>(.*?)</i>.*?<a href="(.*?)">(.*?)</a>', content)
        for thumb,part1,url,part2 in match:
          name = part1 + ' - ' + part2
          addLink(name,url,4,thumb)

def liste(url):
        content = getUrl(url)
        match = re.findall('<div class="pic">.*?<img src="(.*?)".*?<a href="(.*?)">(.*?)</a>',content)
        for cover,url,name in match:
          iurl = url.replace("folge","detail")
	  icontent = getUrl(iurl)
	  info = re.findall('Jahr:</span>(.*?)</.*?Autor:</span>(.*?)</.*?Genre:</span>(.*?)</.*?FSK:</span>(.*?)</.*?Regie:</span>(.*?)</.*?Beschreibung:</span>(.*?)</', icontent)
          for year,autor,genre,fsk,regie,plot in info:
            plot = 'FSK: ' + fsk + '\n\n' + plot
	    cm = []
	    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&mode="+urllib.quote_plus('14')+"&iconimage="+urllib.quote_plus(cover)+"&plot="+urllib.quote_plus(plot)
	    cm.append( ('zu Meine Anime hinzufuegen', "XBMC.RunPlugin(%s)" % u) )
            addDir(name,url,3,cover,plot,genre,year,autor,regie,cm=cm)
        if 'Previous' in content:
          next = re.findall('<div class="pagination">(.*?)</div>', content)
          renext = re.findall('<a href="(http://www.mein.tv/.*?page.*?)".*?>(.*?)</a>', next[0])
          for url,name in renext:
            if 'Next' in name:
              addDir(name,url,2,'','','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def folgen(url):
        content = getUrl(url)
	match = re.findall('<ul>(.*?)</ul>', content)
        rematch = re.findall('<li>.*?<a href="(.*?)" title="(.*?)">.*?<img src="(.*?)".*?<h6>(.*?)</h6>', match[1])
        for url,part2,thumb,part1 in rematch:
          name = part1 + ' - ' + part2
          addLink(name,url,4,thumb)
        next = re.findall('<ul class="nav nav-pills ep_list">(.*?)</ul>',content)
        renext = re.findall('<a href="(.*?)">(.*?)</a>',next[0])
        for url,name in renext:
          addDir('Seite ' + name,url,3,'','','','','','')
        xbmcplugin.endOfDirectory(pluginhandle)

def play(url):
        content = getUrl(url)
        stream = re.findall('playlist:.*?url:"(.*?)st=', content)
	stream = stream[0]+'d=1'
	listitem = xbmcgui.ListItem(path=stream)
        return xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)

def getUrl(url):
	headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 5.1; rv:27.0) Gecko/20100101 Firefox/27.0'}
	content = requests.get(url, headers=headers).content
	content = content.replace("\n","").replace("\t","").replace("&raquo;","").replace("&laquo;","")
        return content

def addLink(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)
        item=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        item.setInfo( type="Video", infoLabels={ "Title": name } )
        item.setProperty('IsPlayable', 'true')
        xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item)

def addDir(name,url,mode,iconimage,plot,genre,year,autor,regie,cm=False):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
        item=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        item.setInfo( type="Video", infoLabels={ "Title": name, "Plot": plot, "Genre": genre, "Year": year, "Writer": autor, "Director": regie } )
        if cm:
          item.addContextMenuItems( cm )
        ok=xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item,isFolder=True)

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
          params=sys.argv[2]
          cleanedparams=params.replace('?','')
          if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
          pairsofparams=cleanedparams.split('&')
          param={}
          for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
              param[splitparams[0]]=splitparams[1]
        return param

params=get_params()
url=None
name=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)

if mode==None:
        kategorien()      

elif mode==1:
        neueanime(url)
        
elif mode==2:
        liste(url)

elif mode==3:
        folgen(url)

elif mode==4:
        play(url)

elif mode==5:
        neueepisoden(url)

elif mode==6:
        serien()

elif mode==7:
        abc(url)

elif mode==8:
        jahr(url)

elif mode==9:
        genre(url)

elif mode==10:
        madamv(url)

elif mode==11:
        suche(url)

elif mode==12:
        listsuche(url)

elif mode==13:
	meine()

elif mode==14:
	add()

elif mode==15:
	rem()

xbmcplugin.endOfDirectory(int(sys.argv[1]))